#include <glylib.h>
#include <AMBER/amber.h>

typedef struct{
	int n;
	char **N;
} natoms;

typedef struct{
        char *O;
        char *C;
        char *R;
        char *Ra;
        char *RN;
        int Rn;
} cxns;

/*The input is natoms structure new[0] which has ring atom names and the number of ring atoms stores in new[0].N and new[0].n respectively. Residue S contains all the atom names in one residue*/

cxns* detect_anomer(natoms* new,residue S,molecule M){

int i=0,j,k,acheck=0;
coord_3D distances;
vectormag_3D temp_blength;
char *atomname;
atomname=(char*)calloc(10,sizeof(char));
cxns*  anomeric= (cxns*)calloc(1,sizeof(cxns));
(*anomeric).C=(char*)calloc(5,sizeof(char));
(*anomeric).O=(char*)calloc(5,sizeof(char));
(*anomeric).O=strdup("NULL");
(*anomeric).C=strdup("NULL");

/*creating a residue called R with just the ring atoms*/
residue R;
R.na=0;
R.a=(atom*)calloc(0,sizeof(atom));
int length;
while(i<new[0].n){
	for(j=0;j<S.na;j++){
		length=strlen(new[0].N[i]);
		if(strncmp(new[0].N[i],S.a[j].N,length) == 0){
			R.na++;
			R.a=(atom*)realloc(R.a,(R.na*sizeof(atom)));
			R.a[R.na-1]=S.a[j];
			//printf("residues %s and %s matched\n",new[0].N[i],S.a[j].N);
			j=S.na;
		}
		
	}
i++;

}

/*creating a residue called other with other atoms of the residue */
residue other;
other.na=0;
other.a=(atom*)calloc(0,sizeof(atom));
for(i=0;i<S.na;i++){
	length=0;
	for(j=0;j<R.na;j++){
		if(strcmp(R.a[j].N,S.a[i].N) == 0){
			length=1;
		}
	}
	if(length==0){
		other.na++;
		other.a=(atom*)realloc(other.a,(other.na*sizeof(atom)));
		other.a[other.na-1]=S.a[i];
	}

}

//printf("R.na is %d\n",R.na);

/*checking for anomeric oxygen. If found, then storing the atoms connected to anomeric oxygen in a residue A*/
residue A;
A.na=0;
A.a=(atom*)calloc(0,sizeof(atom));
int an_check=0;
i=0;
while(i<R.na){
	acheck=0;
	for(j=0;j<R.na;j++){
		if(strcmp(R.a[j].N,R.a[i].N) != 0){
			//printf("distances between %s and %s\n",R.a[j].N,R.a[i].N);
			distances=subtract_coord(R.a[j].x,R.a[i].x);
			temp_blength=coord_to_vec(distances);
			//printf("temp_blength is %f\n",temp_blength.d);
			 if(temp_blength.d<=1.65){
				if(strncmp(R.a[i].N,"O",1) == 0 || strncmp(R.a[i].E,"O",1) == 0){
					A.na++;
					A.a=(atom*)realloc(A.a,(A.na*sizeof(atom)));
					A.a[A.na-1]=R.a[j];
				}	
				acheck++;
			}
		}
	}
	if(acheck==2){
		if(strncmp(R.a[i].N,"O",1) == 0 || strncmp(R.a[i].E,"O",1) == 0){
			A.na++;
			A.a=(atom*)realloc(A.a,(A.na*sizeof(atom)));
			A.a[A.na-1]=R.a[i];
			(*anomeric).O=strdup(R.a[i].N);
			//printf("The anomeric atom is %s\n",R.a[i].N);
			an_check=1;
		}
	}

i++;
}

if(an_check==0){
	//printf("I couldnt detect the anomeric oxygen in this residue\n");
}


//printf("anomeric oxygen is %s\n",anomeric.O);NOMERIC


for(i=0;i<A.na;i++){
	//printf("atomname in residue A is  %s\n",A.a[i].N);
}



i=0;
/* creating a residue O with the remaining atoms of the ring ie.) not the anomeric ring atoms */
residue O;
O.na=0;
O.a=(atom*)calloc(0,sizeof(atom));
int ocheck=0;
if(an_check==1){
	i=0;
	while(i<R.na){
		ocheck=0;
		for(j=0;j<A.na;j++){
			//printf("%s and %s\n",R.a[i].N,A.a[j].N);
			if(strcmp(R.a[i].N,A.a[j].N) == 0){
				//printf("not matched %s\n",R.a[i].N);
				ocheck=1;
			}
		}
		if(ocheck==0){
			//printf("%s\n",A.a[j].N);
			O.na++;
                        O.a=(atom*)realloc(O.a,(O.na*sizeof(atom)));
                        O.a[O.na-1]=R.a[i];
		}
		
	i++;
	}
}

for(i=0;i<O.na;i++){
	//printf("other atoms are %s\n",O.a[i].N);
}

//printf("The remaining atoms size is %d\n",O.na);
/*checking the connections of the atoms connected to anomeric oxygen. Doing this to determine the anomeric carbon*/
i=0;
int rcheck=0,accheck=0;
char *anomer_carbon;
anomer_carbon=(char*)calloc(10,sizeof(char));
if(an_check==1){
	while(i<2){
		accheck=0;
		for(j=0;j<S.na;j++){
			rcheck=0;
			for(k=0;k<R.na;k++){
				if(strcmp(S.a[j].N,R.a[k].N) == 0){
					rcheck=1;
				}
			}
			if(rcheck==0){
				//printf("check distances to atoms %s and %s\n",A.a[i].N,S.a[j].N);
				distances=subtract_coord(A.a[i].x,S.a[j].x);
				temp_blength=coord_to_vec(distances);
				if(temp_blength.d<=1.65){
					//printf("check distances to atoms %s and %s\n",A.a[i].N,S.a[j].N);
					if(strncmp(S.a[j].N,"O",1) == 0){
						//printf("the anomeric carbon is %s\n",A.a[i].N);
						accheck=1;
						(*anomeric).C=strdup(A.a[i].N);	
						anomer_carbon=strdup(A.a[i].N);
						(*anomeric).RN=strdup(S.N);
						(*anomeric).Ra=strdup(S.a[j].N);
						(*anomeric).Rn=j;
					}

				}
			}	
		}

		
	i++;
	}

	//printf("The number of connecting atoms are %d\n",A.na);
}

//printf("accheck is %d\n",accheck);
//printf("anomeric carbon is %s\n",anomeric[0].C);
//printf("dcheck is %d\n",dcheck);
/*if C1 is not connected to any other atoms within the residue then looking for connections in other residues*/

i=0;
if(accheck==0 && M.nr<=1 &&an_check==1){
	while(i<2){
		accheck=0;
		for(j=0;j<S.na;j++){
			rcheck=0;
			for(k=0;k<R.na;k++){
				if(strcmp(S.a[j].N,R.a[k].N) == 0){
					rcheck=1;
				}
			}
			if(rcheck==0){
			distances=subtract_coord(A.a[i].x,S.a[j].x);
                        temp_blength=coord_to_vec(distances);
                        if(temp_blength.d<=1.9){
				if(strncmp(S.a[j].N,"O",1) == 0){
				accheck=1;
                                (*anomeric).C=strdup(A.a[i].N);
                                anomer_carbon=strdup(A.a[i].N);
                                (*anomeric).RN=strdup(S.N);
                                (*anomeric).Ra=strdup(S.a[j].N);
                                (*anomeric).Rn=j;
				}
			}
			}
		}
	i++;
	}
}

//printf("accheck is %d\n",accheck);
//printf("ancheck is %d\n",an_check);
i=0;
if(accheck==0 && M.nr >1 && an_check==1){
	//printf("inside if\n");
	while(i<M.nr){
		//printf("residue %d\n",i+1);
		//printf("inside for\n");
		if(M.r[i].n != S.n){
			//printf("inside second if\n");
			for(j=0;j<2;j++){
					//printf("checking distances of anomer_carbon %s with residue %s\n",A.a[j].N,M.r[i].N);
					for(k=0;k<M.r[i].na;k++){
						//printf("checking distances between %s and %s\n",M.r[i].a[k].N,A.a[j].N);
						distances=subtract_coord(M.r[i].a[k].x,A.a[j].x);
						temp_blength=coord_to_vec(distances);
						//printf("%lf\n",temp_blength.d);
						if(temp_blength.d<=1.9){
							if(strncmp(M.r[i].a[k].N,"O",1) == 0){
							accheck=1;
							//printf("%s is connected to atom %s in residue %s\n",A.a[j].N,M.r[i].a[k].N,M.r[i].N);
							(*anomeric).RN=strdup(M.r[i].N);
							(*anomeric).Ra=strdup(M.r[i].a[k].N);
							(*anomeric).Rn=i+1;
							(*anomeric).C=strdup(A.a[j].N);
							anomer_carbon=strdup(A.a[j].N);
							}
						}
					}
			}
		
		}
		if(accheck==1){
			i=M.nr;
		}
		if(accheck==0){
			i++;
		}
	}

}
//printf("accheck is %d\n",accheck);
i=0;
if(accheck==0 && M.nr>=1 && an_check==1){
        while(i<2){
                accheck=0;
                for(j=0;j<S.na;j++){
                        rcheck=0;
                        for(k=0;k<R.na;k++){
                                if(strcmp(S.a[j].N,R.a[k].N) == 0){
                                        rcheck=1;
                                }
                        }
                        if(rcheck==0){
                        distances=subtract_coord(A.a[i].x,S.a[j].x);
                        temp_blength=coord_to_vec(distances);
                        if(temp_blength.d<=1.9){
				if(strncmp(S.a[j].N,"O",1) == 0){
                                accheck=1;
                                (*anomeric).C=strdup(A.a[i].N);
                                anomer_carbon=strdup(A.a[i].N);
                                (*anomeric).RN=strdup(S.N);
                                (*anomeric).Ra=strdup(S.a[j].N);
                                (*anomeric).Rn=j;
				}
                        }
                        }
                }
        i++;
        }
}


//printf("accheck is %d and dcheck is %d\n",accheck,dcheck);

//printf("anomeric carbon before loop is %s\n",anomeric[0].C);

rcheck=0;
i=0;
molecule LO;
fileset Lset;
fileslurp Lslurp;
Lset.N=strdup("log_residues.pdb");
Lslurp=slurp_file(Lset);
//LO=load_pdb_from_slurp(Lslurp);
int lcheck=0,dcheck=0,tcheck=0,ssize=0,l=0;
char **temp_atoms;
temp_atoms=(char**)calloc(0,sizeof(char*));
//printf("anomeric carbon is %s\n",anomeric[0].C);

if(strcmp((*anomeric).C,"NULL") == 0 && an_check==1){
	
	if(Lslurp.n>1){
		LO=load_pdb_from_slurp(Lslurp);
		while(i<2){
			for(j=0;j<LO.nr;j++){
				for(k=0;k<LO.r[j].na;k++){
					distances=subtract_coord(A.a[i].x,LO.r[j].a[k].x);
					temp_blength=coord_to_vec(distances);
					if(temp_blength.d<1.9 && strncmp(LO.r[j].a[k].N,"H",1) != 0){
						//printf("inside if\n");
						lcheck=1;
						(*anomeric).C=strdup(A.a[i].N);
					}
				}
			}

		i++;
		}
	}

	//printf("anomeric.C is %s\n",anomeric[0].C);


	//printf("atomname is %s\n",atomname);

	for(i=0;i<other.na;i++){
		//printf("the other atoms are %s\n",other.a[i].N);
	}

	tcheck=0,ssize=0,l=0,dcheck=0;
	if(lcheck==0){
	i=0;
	j=0;
	while(i<2){
		j=0;
		ssize=0;
		//printf("atomname is %s\n",A.a[i].N);
		strcpy(atomname,A.a[i].N);
		//printf("atomname is %s\n",atomname);
		while(j<S.na){
			dcheck=0;
			if(strcmp(S.a[j].N,atomname) == 0){
				for(k=0;k<other.na;k++){
				tcheck=0;
				distances=subtract_coord(S.a[j].x,other.a[k].x);
				temp_blength=coord_to_vec(distances);
				if(ssize>0){
					for(l=0;l<ssize;l++){
						if(strcmp(temp_atoms[l],other.a[k].N) == 0){
							tcheck=1;
						}
					}
				}
				if(temp_blength.d<=1.9 && temp_blength.d != 0.0 && tcheck == 0 && strncmp(other.a[k].N,"H",1) != 0){
					ssize++;
					//printf("distance to atoms %s\n",other.a[k].N);
					temp_atoms=(char**)realloc(temp_atoms,(ssize*sizeof(char*)));
					temp_atoms[ssize-1]=strdup(other.a[k].N);
					strcpy(atomname,other.a[k].N);
					//atomname=strdup(other.a[k].N);
					dcheck=1;
				}
				}
			}
			if(dcheck==1){
				j=0;
			}
			else{
				j++;
			}
			
		}//S.na			
		ocheck=0;
		for(l=0;l<ssize;l++){
			if(strncmp(temp_atoms[l],"O",1)==0){
				ocheck++;
			}
		}
		if(ocheck<=2){
			(*anomeric).C=strdup(A.a[i].N);
		}
	
	i++;
		
	}//while
	

	//printf("carbon is %s\n",carbon);
	}

}



return anomeric;
//printf("done\n");
}
