#include <glylib.h>
#include <AMBER/amber.h>

typedef struct {
        int n; /**< number of atoms */
        char **N;
} natoms;


typedef struct{
        char *O;
        char *C;
        char *R;
        char *Ra;
        char *RN;
        int Rn;
}cxns;


typedef struct{
        char *sugar_type;
        char sugar_code[100];
        char *deoxy;
}sugarname;

char* assign_name(sugarname* sname,residue S,molecule M,natoms* cycle_sorted){

fileset Fset;
fileslurp Fslurp;
Fset.N=strdup("/home/spandana/programs/sugar_identification/Pyranoses");
Fslurp=slurp_file(Fset);
//printf("Flsurp.n is %d\n",Fslurp.n);
char *new=(char*)calloc(5,sizeof(char));
char *name=(char*)calloc(30,sizeof(char));
char *c=(char*)calloc(30,sizeof(char));
char *n= (char*)calloc(30,sizeof(char));
char *c1=(char*)calloc(30,sizeof(char));
char *n1=(char*)calloc(30,sizeof(char));
char *c2=(char*)calloc(30,sizeof(char));
char *n2=(char*)calloc(30,sizeof(char));
char *c3=(char*)calloc(30,sizeof(char));
char *n3=(char*)calloc(30,sizeof(char));
int i=0,j=0,k=0,l=0,ocheck=0,length,ncheck=0;
char *sugar_name=(char*)calloc(15,sizeof(char));
//sugar_name=strdup("xxx");
strcpy(sugar_name,"xxx");
coord_3D temp_coord;
initialize_coord_3D(&temp_coord);
//printf("%s\n",sname[0].sugar_type);

//checking to see if any line in the file Pyranose matches the sugar_type
//if it matches then store the sugarname in the variable sugar_name
for(i=0;i<Fslurp.n;i++){
	if(strstr(Fslurp.L[i],sname[0].sugar_type) != NULL){
		//printf("%s",Fslurp.L[i]);
		j=i+1;
		k=1;
		while(k<=1){
			if(strstr(Fslurp.L[j],"TYPE") == NULL && j<Fslurp.n){
				//printf("j is %d\n",j);
				//printf("%s",Fslurp.L[j]);
				sscanf(Fslurp.L[j],"%s%s%s%s%s%s%s%s%s",name,c,n,c1,n1,c2,n2,c3,n3);
				//printf("<<<<<%s %s %s %s %s %s %s %s %s>>>>>\n",name,c,n,c1,n1,c2,n2,c3,n3);
				//printf("sugar_code is <<<%s>>>\n",sname[0].sugar_code);
				//printf("c is <<<%s>>>\n",c);
				length=strlen(sname[0].sugar_code);
				if(strncmp(c,sname[0].sugar_code,length) == 0){	
					//sugar_name=strdup(n);
					strcpy(sugar_name,n);
					ncheck=1;
					//printf("code is %s and name is %s\n",c,n);
				}
				if(strncmp(c1,sname[0].sugar_code,length) == 0){
					//sugar_name=strdup(n1);
					strcpy(sugar_name,n1);
					ncheck=1;
                                        //printf("code is %s and name is %s\n",c1,n1);
                                }
				if(strncmp(c2,sname[0].sugar_code,length) == 0){
					//sugar_name=strdup(n2);
					strcpy(sugar_name,n2);
					ncheck=1;
                                        //printf("code is %s and name is %s\n",c2,n2);
                                }
				if(strncmp(c3,sname[0].sugar_code,length) == 0){
					//sugar_name=strdup(n3);
					strcpy(sugar_name,n3);
					ncheck=1;
                                        //printf("code is %s and name is %s\n",c3,n3);
                                }
				//printf("%s",Fslurp.L[j]);
				j++;
			}
			else{
				k=2;
				//printf("k is %d\n",k);
			}
			if(j==Fslurp.n){
				k=2;
			}
		}
	}
}
			
//printf("sugarname is %s\n",sugar_name);

//storing atomnames and coords of atoms other than the atomsin a cycle (C1-O5)  in arrays called other_atoms and other_coords
vectormag_3D distances;
initialize_vectormag_3D(&distances);
int cycle_check2=0,osize=0;
char **other_atoms;
other_atoms=(char**)calloc(0,sizeof(char*));
coord_3D *other_coords;
other_coords=(coord_3D*)calloc(0,sizeof(coord_3D));
for(i=0;i<S.na;i++){
	cycle_check2=0;
	for(j=0;j<cycle_sorted[0].n;j++){
		if(strcmp(S.a[i].N,cycle_sorted[0].N[j]) ==0){
			cycle_check2=1;
		}
	}
	if(cycle_check2==0){
		osize++;
		other_atoms=(char**)realloc(other_atoms,(osize*sizeof(char*)));
		other_atoms[osize-1]=strdup(S.a[i].N);
		other_coords=(coord_3D*)realloc(other_coords,(osize*sizeof(coord_3D)));
		other_coords[osize-1]=S.a[i].x;
	}
}

/*this loop is just for debugging purposes*/
for(i=0;i<osize;i++){
	//printf("other atoms are %s\n",other_atoms[i]);
}

int cnsize=0;
char **connect_atoms;
connect_atoms=(char**)calloc(0,sizeof(char*));
coord_3D *connect_coords;
connect_coords=(coord_3D*)calloc(0,sizeof(coord_3D*));
int *connect_nos;
connect_nos=(int*)calloc(0,sizeof(int));

//looking for atoms connected to ring atoms and storing them in connect_atoms and connect_coords and connect_nos
for(i=0;i<cycle_sorted[0].n;i++){
	cycle_check2=0;
	for(j=0;j<S.na;j++){
		if(strcmp(cycle_sorted[0].N[i],S.a[j].N) == 0){
			for(k=0;k<osize;k++){
				distances=coord_to_vec(subtract_coord(S.a[j].x,other_coords[k]));
				if(distances.d<1.9){
					cnsize++;
					connect_atoms=(char**)realloc(connect_atoms,(cnsize*sizeof(char*)));
                        		connect_atoms[cnsize-1]=strdup(other_atoms[k]);
					connect_coords=(coord_3D*)realloc(connect_coords,(cnsize*sizeof(coord_3D)));
                        		connect_coords[cnsize-1]=other_coords[k];
					connect_nos=(int*)realloc(connect_nos,(cnsize*sizeof(int)));
					connect_nos[cnsize-1]=i+1;
				}
			}
		}
	}
}

for(i=0;i<cnsize;i++){
	//printf("%s\n",connect_atoms[i]);
}	

//checking for atoms which are not common to both arrays connect and other atoms
for(i=0;i<cnsize;i++){
	for(j=0;j<osize;j++){
		if(strcmp(connect_atoms[i],other_atoms[j]) != 0){
			distances=coord_to_vec(subtract_coord(connect_coords[i],other_coords[j]));
			if(distances.d<1.9){
				//connect_atoms[i]=other_atoms[j];
				//connect_coords[i]=other_coords[j];
				//printf("distances between %s and %s\n",connect_atoms[i],other_atoms[j]);
			}
		}
	}


}

/*this is for debugging purposes too */
for(i=0;i<cnsize;i++){
        //printf("%s\n",connect_atoms[i]);
	//dprint_coord_3D(&connect_coords[i]);
}


//storing coordinates of cycle_atoms in cycle_coords
int ccsize=0;
coord_3D **cycle_coords;
cycle_coords=(coord_3D**)calloc(0,sizeof(coord_3D*));
for(i=0;i<cycle_sorted[0].n;i++){
        for(j=0;j<S.na;j++){
                if(strcmp(cycle_sorted[0].N[i],S.a[j].N) == 0){
                        ccsize++;
                        cycle_coords=(coord_3D**)realloc(cycle_coords,(ccsize*sizeof(coord_3D*)));
                        cycle_coords[ccsize-1]=&S.a[j].x;
                        //dprint_coord_3D(&cycle_coords[ccsize-1][0]);
                }
        }
}



int ri=0,ai=0,ccheck=0,dcheck=0,acheck=0;
char *atomname;
atomname=(char*)calloc(6,sizeof(char));
char **aminoatoms;
aminoatoms=(char**)calloc(0,sizeof(char*));
char **sulfateatoms;
sulfateatoms=(char**)calloc(0,sizeof(char*));
int *sulfate_nos;
sulfate_nos=(int*)calloc(0,sizeof(int));
int nssize=0,ssize=0,asize=0,name_check=0,amino_check=0,slurpcheck=0;
molecule LO;
fileslurp Lslurp;
fileset Lset;
Lset.N=strdup("log_residues.pdb");
Lslurp=slurp_file(Lset);


//checking if there are any residues in the log file, if yes then load them into the molecule LO
if(Lslurp.n>0){
	slurpcheck=1;
	LO=load_pdb_from_slurp(Lslurp);
}



int aminocheck=0,Nsulfate_check=0,Nsulfate_check2=0;
/*ncheck = 1 if sugar_name is found in the pyranose file*/
if(ncheck==1){
	if(strcmp(sname[0].sugar_type,"AMINO DERIVATIVES") == 0){
		strcpy(atomname,cycle_sorted[0].N[1]);
		//atomname=strdup(cycle_sorted[0].N[1]);
		while(ai<S.na){
			dcheck=0;
			if(strcmp(S.a[ai].N,atomname) == 0){
				for(i=0;i<S.na;i++){
					ccheck=0;
					acheck=0;
					for(j=0;j<cycle_sorted[0].n;j++){
						if(strcmp(S.a[i].N,cycle_sorted[0].N[j]) == 0){
							ccheck=1;
						}
					}
					if(asize>0){
						for(k=0;k<asize;k++){
							if(strcmp(S.a[i].N,aminoatoms[k]) ==0){
								acheck=1;
							}
						}
					}
					if(ccheck==0 && acheck==0){
						distances=coord_to_vec(subtract_coord(S.a[ai].x,S.a[i].x));
						if(distances.d<1.9 && strcmp(S.a[ai].N,S.a[i].N) != 0){
							asize++;
							//printf("atom %s is connected to %s\n",S.a[ai].N,S.a[i].N);
							//printf("asize is %d\n",asize);
							aminoatoms=(char**)realloc(aminoatoms,(asize*sizeof(char*)));
							//strcpy(aminoatoms[asize-1],S.a[i].N);
							aminoatoms[asize-1]=strdup(S.a[i].N);
							strcpy(atomname,S.a[i].N);
							dcheck=1;
							//printf("atom %s is connected to %s\n",S.a[ai].N,S.a[i].N);
						}
					}
				}
			}
			if(dcheck==1){
				ai=0;
			}
			else{
				ai++;
			}
		}//S.na

		//printf("done\n");	
		ccheck=0;
		ocheck=0;
		aminocheck=0,Nsulfate_check=0,Nsulfate_check2=0;
		for(i=0;i<asize;i++){
			if(strncmp(aminoatoms[i],"N",1)!= 0){
				if(strncmp(aminoatoms[i],"C",1) == 0){
					ccheck++;		
				}
				if(strncmp(aminoatoms[i],"O",1) ==0 || strstr(aminoatoms[i],"S") != NULL){
					ocheck++;
				}
				
			}
		}
		//printf("ocheck is %d\n",ocheck);
		if(ccheck==2){
                        aminocheck=1;
                        //printf("this is an amino derivative\n");
                }
                if(ocheck==4){
                        Nsulfate_check=1;
			strcat(sugar_name,"[NS]");
                        //printf("this is N sulfated\n");
                }
		if(aminocheck==0 && Nsulfate_check==0){
			ssize=0;
			for(i=0;i<S.na;i++){
				if(strcmp(S.a[i].N,aminoatoms[0]) == 0){
					if(slurpcheck==1){
					for(ri=0;ri<LO.nr;ri++){
						for(ai=0;ai<LO.r[ri].na;ai++){
							distances=coord_to_vec(subtract_coord(S.a[i].x,LO.r[ri].a[ai].x));
							if(distances.d<1.95){
								ssize++;
								sulfateatoms=(char**)realloc(sulfateatoms,(ssize*sizeof(char*)));
	                                                        sulfateatoms[ssize-1]=strdup(LO.r[ri].a[ai].N);
							}
				
						}	

					}
					}
				}
			}
			ocheck=0;
			for(i=0;i<ssize;i++){
                                if(strncmp(sulfateatoms[i],"O",1) ==0 || strstr(sulfateatoms[i],"S") != NULL){
                                        ocheck++;
                                }

                	}
			if(ocheck==4){
                        	Nsulfate_check2=1;
				strcat(sugar_name,"[NS]");
				amino_check=1;
                        	//printf("this is N sulfated and sulfates are a separate residue\n");
                	}

		}//aminocheck and Nsulfate	


			//printf("inside if\n");
	}//amino derivatives;	


	char **sulfateatoms2;
	sulfateatoms2=(char**)calloc(0,sizeof(char*));	
	if(strcmp(sname[0].sugar_type,"ACIDS")== 0 || strcmp(sname[0].sugar_type,"AMINO DERIVATIVES") == 0){
		int temp=0;
		if(Nsulfate_check==0 && Nsulfate_check2==0){
			temp=0;
		}
		else{
			temp=2;
		}
		for(i=temp;i<cycle_sorted[0].n;i++){
			ssize=0;
			strcpy(atomname,cycle_sorted[0].N[i]);
			//atomname=strdup(cycle_sorted[0].N[i]);
			j=0;
			while(j<S.na){
				dcheck=0;
				if(strcmp(S.a[j].N,atomname) == 0){
					for(k=0;k<osize;k++){
						acheck=0;
						distances=coord_to_vec(subtract_coord(S.a[j].x,other_coords[k]));
						if(ssize>0){
							for(l=0;l<ssize;l++){
								if(strcmp(sulfateatoms2[l],other_atoms[k]) == 0){
									acheck=1;
								}
							}
						}
						if(distances.d<1.9 && distances.d!=0.0 && acheck==0){
							//printf("distances to atoms %s\n",other_atoms[k]);
							ssize++;
							sulfateatoms2=(char**)realloc(sulfateatoms2,(ssize*sizeof(char*)));
							sulfateatoms2[ssize-1]=other_atoms[k];
							//atomname=other_atoms[k];
							strcpy(atomname,other_atoms[k]);
							dcheck=1;			
						}
					}
				}
				if(dcheck==1){
					j=0;
				}
				else{
				j++;
				}

			}//while
				ocheck=0;
                                for(l=0;l<ssize;l++){
					//printf("sulfateatoms are %s\n",sulfateatoms[l]);
                                        if(strncmp(sulfateatoms2[l],"O",1) == 0 || strstr(sulfateatoms2[l],"S") != NULL){
						//printf("<<<sulfateatoms are %s\n",sulfateatoms[l]);
                                        ocheck++;
                                        }
                                }
				//printf("ocheck is %d\n",ocheck);
                                if(ocheck>=4){
					nssize++;
					sulfate_nos=(int*)realloc(sulfate_nos,(nssize*sizeof(int)));
					sulfate_nos[nssize-1]=i;
					sprintf(new,"[%dS]",i+1);
					strcat(sugar_name,new);
					name_check=1;
                                        //printf("this is %d sulfated\n",i+1);
                                }
 

		}//for 	
		


char **sulfateatoms3;
sulfateatoms3=(char**)calloc(0,sizeof(char*));


//check this loop
	for(i=0;i<cnsize;i++){
		ssize=0;
		temp_coord=(connect_coords[i]);
		if(slurpcheck==1){
		for(ri=0;ri<LO.nr;ri++){
			ai=0;
			for(ai=0;ai<LO.r[ri].na;ai++){
				distances=coord_to_vec(subtract_coord(LO.r[ri].a[ai].x,connect_coords[i]));
				if(distances.d<1.9){
					ssize++;
					sulfateatoms3=(char**)realloc(sulfateatoms3,(ssize*sizeof(char*)));
					sulfateatoms3[ssize-1]=strdup(LO.r[ri].a[ai].N);
					//strcpy(sulfateatoms[ssize-1],LO.r[ri].a[ai].N);
					temp_coord=LO.r[ri].a[ai].x;
					j=0;
					while(j<LO.r[ri].na){
						dcheck=0;
						acheck=0;
                                                distances=coord_to_vec(subtract_coord(LO.r[ri].a[j].x,temp_coord));
						if(ssize>0){
							for(k=0;k<ssize;k++){
								if(strcmp(LO.r[ri].a[j].N,sulfateatoms3[k]) == 0){
									acheck=1;
								}
							}
						}	
                                                if(distances.d<1.9 && distances.d!=0.0 && acheck ==0){
                                                        //printf("distances to atoms %s\n",LO.r[ri].a[ai].N);
                                                        ssize++;
                                                        sulfateatoms3=(char**)realloc(sulfateatoms3,(ssize*sizeof(char*)));
                                                        //strcpy(sulfateatoms[ssize-1],LO.r[ri].a[j].N);
							sulfateatoms3[ssize-1]=strdup(LO.r[ri].a[j].N);
                                                	dcheck=1;
						}
						if(dcheck==1){
							j=0;
						}
						else{
							j++;
						}

	                                 }
                                }
			}
                                //printf("done\n");

		}//nr
		}//if
                ocheck=0;
                for(j=0;j<ssize;j++){
                	if(strncmp(sulfateatoms3[j],"O",1) ==0 || strstr(sulfateatoms3[j],"S") != NULL){
                        	ocheck++;
                        }

                }
                if(ocheck>=4){
			sprintf(new,"[%dS]",i+1);
			nssize++;
			sulfate_nos=(int*)realloc(sulfate_nos,(nssize*sizeof(int)));
			sulfate_nos[nssize-1]=i;
			strcat(sugar_name,new);
			name_check=1;
                	//printf("this is %d sulfated\n",connect_nos[i]);
                                //it can have multiple sulfations so make an array to store that 
                }

	}//cnsize


	}//acids
		
}//ncheck


char **sulfateatoms4;
sulfateatoms4=(char**)calloc(0,sizeof(char*));
	if(strcmp(sname[0].sugar_type,"NEURAMINICACID")== 0){
			ssize=0;
			//printf("sugar_type is %s\n",sname[0].sugar_type);
                        //atomname=strdup(cycle_sorted[0].N[3]);
                        strcpy(atomname,cycle_sorted[0].N[3]);
			j=0;
                        while(j<S.na){
                                dcheck=0;
                                if(strcmp(S.a[j].N,atomname) == 0){
                                        for(k=0;k<osize;k++){
                                                acheck=0;
						
                                                distances=coord_to_vec(subtract_coord(S.a[j].x,other_coords[k]));
                                                if(ssize>0){
                                                        for(l=0;l<ssize;l++){
                                                                if(strcmp(sulfateatoms4[l],other_atoms[k]) == 0){
                                                                        acheck=1;
                                                                }
                                                        }
                                                }
                                                if(distances.d<1.9 && distances.d!=0.0 && acheck==0 && strncmp(other_atoms[k],"H",1) != 0){
                                                        //printf("distances to atoms %s\n",other_atoms[k]);
                                                        ssize++;
                                                        sulfateatoms4=(char**)realloc(sulfateatoms4,(ssize*sizeof(char*)));
                                                        sulfateatoms4[ssize-1]=strdup(other_atoms[k]);
                                                        //strcpy(sulfateatoms[ssize-1],other_atoms[k]);
							//atomname=other_atoms[k];
                                                        strcpy(atomname,other_atoms[k]);
							dcheck=1;
                                                }
                                        }
                                }
                                if(dcheck==1){
                                        j=0;
                                }
                                else{
                                j++;
                                }

                        }//while
                                ocheck=0;
                                for(l=0;l<ssize;l++){
                                        //printf("sulfateatoms are %s\n",sulfateatoms[l]);
                                        if(strncmp(sulfateatoms4[l],"O",1) == 0 || strncmp(sulfateatoms4[l],"C",1) == 0){
                                        ocheck++;
                                        }
                                }
                                if(ocheck==3){
					strcpy(sugar_name,"Neu5Ac");
					//sugar_name=strdup("Neu5Ac");
                                        //printf("this is Neu5Ac\n");
                                }
				if(ocheck==4){
					strcpy(sugar_name,"Neu5Gc");
					//sugar_name=strdup("Neu5Gc");
					//printf("this is Neu5Gc\n");
				}

	}//neuraminic acid

int no_connections=0;
char **hexatoms;
hexatoms=(char**)calloc(0,sizeof(char*));
int cccheck=0;
ssize=0;
//printf("%s\n",sname[0].sugar_type);
//this is to check if they are really neuraminic acid or hexose or pentose_ketose or a furanose. Sometimes, they are connected to other atoms (for example C2 might be connected to some other atom other than O2 in a glucose like a Fe or something)
if(strcmp(sname[0].sugar_type,"NEURAMINICACID") == 0 || strcmp(sname[0].sugar_type,"HEXOSES") == 0 || strcmp(sname[0].sugar_type,"PENTOSES_KETOSES") == 0 || strstr(sname[0].sugar_type,"FURANOSE") != NULL){
	//printf("inside if\n");
	for(i=0;i<cycle_sorted[0].n-1;i++){
		temp_coord=cycle_coords[i][0];
		j=0;
		ssize=0;
		no_connections=0;
		while(j<osize){
			dcheck=0;
			cccheck=0;
			distances=coord_to_vec(subtract_coord(temp_coord,other_coords[j]));
			if(ssize>0){
			for(k=0;k<ssize;k++){
				if(strcmp(other_atoms[j],hexatoms[k]) == 0){
					dcheck=1;
				}	
			}
			}
			//printf("dcheck is %d\n",dcheck);
			if(distances.d<1.9 && dcheck==0 && distances.d != 0.0){
				if(strncmp(other_atoms[j],"H",1) != 0){
				//printf("distances between %s and %s\n",cycle_sorted[0].N[i],other_atoms[j]);
                       // printf("%lf\n",distances.d);	
				temp_coord=other_coords[j];
				cccheck=1;
				no_connections++;
				ssize++;
				hexatoms=(char**)realloc(hexatoms,(ssize*sizeof(char*)));
				hexatoms[ssize-1]=strdup(other_atoms[j]);
				//strcpy(hexatoms[ssize-1],other_atoms[j]);
				}
			}
			if(cccheck==1){
				j=0;
			}
			else{
				j++;
			}	

			}
	

	//checking if there is something else other than Oxygen connected to each of the hexoses. sometimes there are sugars like Glucose-2,3XXX 
	if(strcmp(sname[0].sugar_type,"HEXOSES") == 0){
		if(i==1 || i==2 || i==3){
			if(no_connections<0){
				strcpy(sugar_name,"HPX");
				//sugar_name=strdup("HPX");
			}
			if(no_connections>1){
				strcpy(sugar_name,"HPX");
				//sugar_name=strdup("HPX");
			}
			if(no_connections>2){
				strcpy(sugar_name,"HPX");
				//sugar_name=strdup("HPX");
			}
			if(no_connections==1){
				//printf("here\n");
				if(strncmp(hexatoms[0],"O",1) != 0){
					strcpy(sugar_name,"HPX");
					//sugar_name=strdup("HPX");
				}
			}
		}
		
		if(i==4){
			if(no_connections>2){
				strcpy(sugar_name,"HPX");
				//sugar_name=strdup("HPX");
			}
			if(no_connections ==2 ){
				//printf("here>>>\n");
				for(k=0;k<ssize;k++){
					//printf("%s\n",hexatoms[k]);
					if(strncmp(hexatoms[k],"C",1) != 0 && strncmp(hexatoms[k],"O",1) != 0){
						//printf("here\n");
						strcpy(sugar_name,"HPX");
						//sugar_name=strdup("HPX");
					}
				}
			}	
					
		}
	}

	if(strcmp(sname[0].sugar_type,"PENTOSES_KETOSES") == 0){
		//printf("inside here\n");
		if(no_connections>2){
			strcpy(sugar_name,"HPX");
			//sugar_name=strdup("HPX");
		}
		if(i==0){
			if(no_connections==1){
				if(strncmp(hexatoms[0],"O",1) != 0){
					strcpy(sugar_name,"HPX");
					//sugar_name=strdup("HPX");
				}
			}
		}			

		if(i==1 || i==2 || i==3){
			if(no_connections ==1){
				if(strncmp(hexatoms[0],"O",1) != 0){
					strcpy(sugar_name,"HPX");
					//sugar_name=strdup("HPX");
				}
			}
		}
		if(i==4){
			if(no_connections >0){
				strcpy(sugar_name,"HPX");
				//sugar_name=strdup("HPX");
			}
		}

	}

	if(strcmp(sname[0].sugar_type,"FURANOSE_PENTOSES") == 0 || strcmp(sname[0].sugar_type,"FURANOSE_KETOSES") == 0){
		for(k=0;k<ssize;k++){
			if(strncmp(hexatoms[k],"C",1) != 0 && strncmp(hexatoms[k],"O",1) != 0){
				strcpy(sugar_name,"HPX");
				//sugar_name=strdup("HPX");
			}
		}	

	}
	
	if(strcmp(sname[0].sugar_type,"NEURAMINICACID") ==0){
		if(i==0 || i==1|| i==2){
			for(k=0;k<ssize;k++){
                        if(strncmp(hexatoms[k],"C",1) != 0 && strncmp(hexatoms[k],"O",1) != 0){
                                strcpy(sugar_name,"HPX");
				//sugar_name=strdup("HPX");
                        }
			}
                }
		if(i==3){
			 for(k=0;k<ssize;k++){
                        if(strncmp(hexatoms[k],"C",1) != 0 && strncmp(hexatoms[k],"O",1) != 0 && strncmp(hexatoms[k],"N",1) != 0){
                                strcpy(sugar_name,"HPX");
				//sugar_name=strdup("HPX");
                        }
			}
		}
		if(i==4){
			 for(k=0;k<ssize;k++){
                        if(strncmp(hexatoms[k],"C",1) != 0 && strncmp(hexatoms[k],"O",1) != 0){
                                strcpy(sugar_name,"HPX");
				//sugar_name=strdup("HPX");
                        }
                        }
		}
	}



}//for
}//if hexoses,pentoses,ketoses


if(strcmp(sname[0].sugar_type,"DEOXY SUGARS") == 0 && ncheck==0){
	strcpy(sugar_name,"DXX");
	//sugar_name=strdup("DXX");
}
//printf("done\n");

return sugar_name;

}
