#include<glylib.h>
#include<AMBER/amber.h>

typedef struct {
	int n;
	char **N;
}natoms;

typedef struct{
	char *O;
	char *C;
	char *R;
	char *Ra;
	char *RN;
	int Rn;
}cxns;


typedef struct{
	char *sugar_type;
	char sugar_code[100];
	char *deoxy;
}sugarname;

sugarname* identify_name(residue S,int resno,natoms* cycle_sorted,cxns* anomeric,molecule M){

int i=0,j=0,k=0,l=0,ai=0,planesize=0;
plane *planes;
sugarname* sname = (sugarname*)calloc(1,sizeof(sugarname));
(*sname).sugar_type=(char*)calloc(10,sizeof(char));
(*sname).deoxy = (char*)calloc(10,sizeof(char));
(*sname).sugar_type=strdup("xxx");
(*sname).deoxy=strdup("no");
if(cycle_sorted[0].n==6){
	planesize=5*3;
	planes=(plane*)calloc(5,sizeof(plane));
}
if(cycle_sorted[0].n==5){
	planesize=4*3;
	planes=(plane*)calloc(4,sizeof(plane));
}

coord_3D **plane_coords;
plane_coords=(coord_3D**)calloc(planesize,sizeof(coord_3D*));

for(ai=0;ai<S.na;ai++){
	if(strcmp(S.a[ai].N,anomeric[0].O) == 0){
		plane_coords[0]=&S.a[ai].x;
	}
	if(strcmp(S.a[ai].N,cycle_sorted[0].N[0]) == 0){
		plane_coords[1]=&S.a[ai].x;
	}
	if(strcmp(S.a[ai].N,cycle_sorted[0].N[1]) == 0){
		plane_coords[2]=&S.a[ai].x;
	}
}

i=3;
j=0;
k=3;
l=0;
while(i<planesize){
	ai=0;
	//printf("i is %d\n",i);
	//printf("k is %d\n",k);
	while(ai<S.na && j<cycle_sorted[0].n){
		//printf("j is %d\n",j);
		if(strcmp(S.a[ai].N,cycle_sorted[0].N[j]) == 0){
			//printf("atom name is %s\n",S.a[ai].N);

			plane_coords[k]=&S.a[ai].x;
			//printf("k is %d\n",k);
			//dprint_coord_3D(&S.a[ai].x);
		}
		ai++;
	}
	if(k>=i+3){
		i=i+3;
                l++;
                j=l;
                }
	else{
		j++;
		k++;
	}
}

	
for(i=0;i<planesize;i++){
	//dprint_coord_3D(&plane_coords[i][0]);
}

coord_3D **ring_atoms;
ring_atoms=(coord_3D**)calloc(0,sizeof(coord_3D*));
int rsize=0,check=0;
for(i=0;i<cycle_sorted[0].n;i++){
	check=0;
	ai=0;
	while(ai<S.na){
		if(strcmp(S.a[ai].N,cycle_sorted[0].N[i]) == 0){
			check=1;
		}
		if(check==1){
			rsize++;
			ring_atoms=(coord_3D**)realloc(ring_atoms,(rsize*sizeof(coord_3D*)));
			ring_atoms[rsize-1]=&S.a[ai].x;
			ai=S.na;
		}
		ai++;
	}
}

for(i=0;i<rsize;i++){
	//printf("The atom name is %s ",cycle_sorted[0].N[i]);
	//dprint_coord_3D(&ring_atoms[i][0]);
}



check=0;
int csize=0,dcheck=0,c1size=0;
coord_3D **connect_atoms;
connect_atoms=(coord_3D**)calloc(0,sizeof(coord_3D*));
char **connect_atomnames;
connect_atomnames=(char**)calloc(0,sizeof(char*));
coord_3D **c1_connectatoms;
c1_connectatoms=(coord_3D**)calloc(0,sizeof(coord_3D*));
char **c1_connectatomnames;
c1_connectatomnames=(char**)calloc(0,sizeof(char*));
char **connect_elenames;
connect_elenames=(char**)calloc(0,sizeof(char*));
coord_3D zero;
zero.i=0.0;
zero.j=0.0;
zero.k=0.0;
vectormag_3D distances;
initialize_vectormag_3D(&distances);
for(i=0;i<rsize-1;i++){
	//dprint_coord_3D(&ring_atoms[i][0]);
	dcheck=0;
	for(j=0;j<M.nr;j++){
		for(k=0;k<M.r[j].na;k++){
			check=0;
			if(j==resno){
				for(l=0;l<cycle_sorted[0].n;l++){
					if(strcmp(cycle_sorted[0].N[l],M.r[j].a[k].N) == 0){
						check=1;
					}
				}
			}
			if(check==0){
				distances=coord_to_vec(subtract_coord(ring_atoms[i][0],M.r[j].a[k].x));
				if(distances.d<=1.9 && strncmp(M.r[j].a[k].N,"H",1) !=0){
					dcheck=1;
					if(i==0){
						c1size++;
						c1_connectatoms=(coord_3D**)realloc(c1_connectatoms,(c1size*sizeof(coord_3D*)));
						c1_connectatoms[c1size-1]=&M.r[j].a[k].x;
						c1_connectatomnames=(char**)realloc(c1_connectatomnames,(c1size*sizeof(char*)));
						c1_connectatomnames[c1size-1]=strdup(M.r[j].a[k].N);
					}
				else{
				csize++;
				connect_atoms=(coord_3D**)realloc(connect_atoms,(csize*sizeof(coord_3D*)));
				connect_atoms[csize-1]=&M.r[j].a[k].x;
				connect_atomnames=(char**)realloc(connect_atomnames,(csize*sizeof(char*)));
				connect_atomnames[csize-1]=M.r[j].a[k].N;
				connect_elenames=(char**)realloc(connect_elenames,(csize*sizeof(char*)));
				connect_elenames[csize-1]=M.r[j].a[k].E;
				}
				}
	
			}
		}
	}
	if(dcheck==0){

		if(i==0){
			c1size++;
                                                c1_connectatoms=(coord_3D**)realloc(c1_connectatoms,(c1size*sizeof(coord_3D*)));
                                                c1_connectatoms[c1size-1]=&zero;
                                                c1_connectatomnames=(char**)realloc(c1_connectatomnames,(c1size*sizeof(char*)));
                                                c1_connectatomnames[c1size-1]=strdup("XX");
		}
		else{
		csize++;
		connect_atoms=(coord_3D**)realloc(connect_atoms,(csize*sizeof(coord_3D*)));
		connect_atoms[csize-1]=&zero;
		connect_atomnames=(char**)realloc(connect_atomnames,(csize*sizeof(char*)));
		connect_atomnames[csize-1]=strdup("XX");
		}
	}

}

//printf("csize is %d\n",csize);

for(i=0;i<csize;i++){
//printf("The connection atoms are %s\n",connect_atomnames[i]);
}



//printf("<<<done>>>\n");

int atoms=0;
if(cycle_sorted[0].n==5){
	atoms=3;
}

if(cycle_sorted[0].n==6){
	atoms=4;
}

		
//printf("<<<done\n");
molecule LO; 
fileslurp Lslurp;
fileset Lset;
Lset.N=strdup("log_residues.pdb");
//printf("<<<%s>>\n",Lset.N);
Lslurp=slurp_file(Lset);
if(Lslurp.n>0){
LO=load_pdb_from_slurp(Lslurp);
for(i=0;i<1;i++){
	for(j=0;j<LO.nr;j++){
		for(k=0;k<LO.r[j].na;k++){
			distances=coord_to_vec(subtract_coord(ring_atoms[i][0],LO.r[j].a[k].x));
			if( distances.d<=1.9 && strncmp(LO.r[j].a[k].N,"H",1) != 0){
				c1size++;
                                c1_connectatoms=(coord_3D**)realloc(c1_connectatoms,(c1size*sizeof(coord_3D*)));
                                c1_connectatoms[c1size-1]=&LO.r[j].a[k].x;
                                c1_connectatomnames=(char**)realloc(c1_connectatomnames,(c1size*sizeof(char*)));
                                c1_connectatomnames[c1size-1]=strdup(LO.r[j].a[k].N);	
			}
		}
	}
	
}
}



for(i=0;i<csize;i++){
	//dprint_coord_3D(&c1_connectatoms[i][0]);
	//printf("%s\n",connect_atomnames[i]);
}

coord_3D one,two,three;
initialize_coord_3D(&one);
initialize_coord_3D(&two);
initialize_coord_3D(&three);
//calculating all the 3 atom planes
j=0;
for(i=0;i<planesize/3;i++){
	one=plane_coords[j][0];
	two=plane_coords[j+1][0];
	three=plane_coords[j+2][0];
	//dprint_coord_3D(&plane_coords[j][0]);
	//dprint_coord_3D(&plane_coords[j+1][0]);
	//dprint_coord_3D(&plane_coords[j+2][0]);
	//planes[i]=get_plane_for_ring(no,three);
	planes[i]=get_plane(one,two,three);
	j=j+3;
}

//printf("2done\n");
//printf("csize is %d\n",csize);	
//calculating vector between ringatoms and connected atoms
vectormag_3D *vec_connectatoms;
vec_connectatoms=(vectormag_3D*)calloc(csize,sizeof(vectormag_3D));
//printf("csize is %d\n",csize);
for(i=0;i<csize;i++){
	if(strstr(connect_atomnames[i],"XX")== NULL){
		vec_connectatoms[i]=coord_to_vec(subtract_coord(ring_atoms[i+1][0],connect_atoms[i][0]));
		//printf("vector between atoms %s and %s\n",connect_atomnames[i],cycle_sorted[0].N[i]);
	}
	if(strstr(connect_atomnames[i],"XX")!= NULL){
		vec_connectatoms[i].i=0.0;
		vec_connectatoms[i].j=0.0;
		vec_connectatoms[i].k=0.0;
		vec_connectatoms[i].d=0.0;
	}
	//dprint_coord_3D(&connect_atoms[i][0]);
	//dprint_coord_3D(&ring_atoms[i+1][0]);
	//dprint_vectormag_3D(&vec_connectatoms[i]);

}

char c1[10];
char *c2;
c2=(char*)calloc(5,sizeof(char));
char *c3;
c3=(char*)calloc(5,sizeof(char));
char *c4;
c4=(char*)calloc(5,sizeof(char));
char *c6;
c6=(char*)calloc(5,sizeof(char));
c2=strdup("n");
c3=strdup("n");
c4=strdup("n");
c6=strdup("n");
double d=0.0;
vectormag_3D vec_planes;
initialize_vectormag_3D(&vec_planes);
//checking the orientation of second,third and fourth ring atoms (C2,C3,C4 for pyranoses or C2,C3 for furanoses)
int index=cycle_sorted[0].n;
i=index-(index-1);
int ncheck=0,acheck=0,accheck=0,two_dcheck=0,three_dcheck=0,four_dcheck=0,six_dcheck=0,hcheck=0,pkcheck=0;
d=0.0;
vec_planes.i=planes[i].A;
vec_planes.j=planes[i].B;
vec_planes.k=planes[i].C;
if(strcmp(connect_atomnames[i-1],"XX")== 0){
	two_dcheck=1;
	c2=strdup("n");
}
if(strcmp(connect_atomnames[i-1],"XX") != 0){
	d=get_dotprod(vec_planes,vec_connectatoms[i-1]);
	//printf("the vectormag is\n");
	//dprint_vectormag_3D(&vec_connectatoms[i]);
	//printf("The dot product of atom %s with plane %d is %lf\n",connect_atomnames[i],i,d);
	if(strncmp(connect_atomnames[i-1],"O",1) != 0 && strncmp(connect_atomnames[i-1],"N",1) == 0){
        	acheck=1;
	}
	else{
        	if(strncmp(connect_elenames[i-1],"O",1) != 0 && strncmp(connect_elenames[i-1],"N",1) == 0){
                	acheck=1;
        	}
	}

	if(d<0){
		c2=strdup("_2");
	}
	if(d>0){
		c2=strdup("^2");
	}
}
//printf("c2 is %s\n",c2);
	
i=index-(index-2);
d=0.0;
vec_planes.i=planes[i].A;
vec_planes.j=planes[i].B;
vec_planes.k=planes[i].C;
if(strcmp(connect_atomnames[i-1],"XX")== 0){
	three_dcheck=1;
	c3=strdup("n");
}
if(strcmp(connect_atomnames[i-1],"XX") != 0){
	d=get_dotprod(vec_planes,vec_connectatoms[i-1]);
	//printf("The dot product of atom %s with plane %d is %lf\n",connect_atomnames[i],i,d);
	if(d<0){
		c3=strdup("_3");
	}
	if(d>0){
		c3=strdup("^3");
	}
}
//printf("c3 is %s\n",c3);

//printf("cycle_sorted[0] is %d\n",cycle_sorted[0].n);
if(cycle_sorted[0].n==6){
	//printf("its a pyranose\n");
	d=0.0;
	i=index-(index-3);
	vec_planes.i=planes[i].A;
	vec_planes.j=planes[i].B;
	vec_planes.k=planes[i].C;
	if(strcmp(connect_atomnames[i-1],"XX") == 0){
		four_dcheck=1;
		c4=strdup("n");
	}
	//printf("C4 is %s\n",connect_atomnames[i-1]);
	if(strcmp(connect_atomnames[i-1],"XX") != 0){
		if(strncmp(connect_atomnames[i-1],"N",1) == 0){
                	ncheck=1;
        	}
        	else{
                	if(strncmp(connect_elenames[i-1],"N",1) == 0){
                        	ncheck=1;
                	}
        	}
		d=get_dotprod(vec_planes,vec_connectatoms[i-1]);
		//printf("The dot product of atom %s with plane %d is %lf\n",connect_atomnames[i],i,d);
	
		if(d<0){
			c4=strdup("_4");
		}
		if(d>0){
			c4=strdup("^4");
		}
	}
}
//printf("c4 is %s\n",c4);


//checking connections of C6
char **c6_connectatomnames;
c6_connectatomnames=(char**)calloc(0,sizeof(char*));
coord_3D **c6_connectatoms;
c6_connectatoms=(coord_3D**)calloc(1,sizeof(coord_3D*));
int no_connections=0;
int c6size=0;
int ccheck=0;
if(strcmp(connect_atomnames[csize-1],"XX") == 0){
	pkcheck=1;
}

if(strcmp(connect_atomnames[csize-1],"XX") != 0){
	//printf("checking connections of c6\n");
	for(i=0;i<S.na;i++){
		//printf("inside if\n");
		ccheck=0;
		for(j=0;j<cycle_sorted[0].n;j++){
			if(strcmp(cycle_sorted[0].N[j],S.a[i].N) == 0 || strcmp(connect_atomnames[csize-1],S.a[i].N) == 0){
				ccheck=1;
			}
		}
		if(ccheck==0){
			//printf("%s\n",S.a[i].N);
			if(strncmp(S.a[i].N,"H",1) != 0){
				distances=coord_to_vec(subtract_coord(connect_atoms[csize-1][0],S.a[i].x));
				if(distances.d<=1.9){
					c6size++;
					c6_connectatomnames=(char**)realloc(c6_connectatomnames,(c6size*sizeof(char*)));
					c6_connectatomnames[c6size-1]=strdup(S.a[i].N);
					c6_connectatoms=(coord_3D**)realloc(c6_connectatoms,(c6size*sizeof(coord_3D*)));
					c6_connectatoms[c6size-1]=&S.a[i].x;
					no_connections++;
					//printf("The connections are %s\n",S.a[i].N);
				}
			}
		}
	}

	if(cycle_sorted[0].n==6){
		i=index-(index-3);
	}
	if(cycle_sorted[0].n==5){
		i=index-(index-2);
	}
	vec_planes.i=planes[i+1].A;
	vec_planes.j=planes[i+1].B;
	vec_planes.k=planes[i+1].C;
	d=get_dotprod(vec_planes,vec_connectatoms[i]);
	//printf("The dot product of atom %s with plane %d is %lf\n",connect_atomnames[i],i+1,d);
	if(d<0.0){
		c6=strdup("_1");
	}
	if(d>0.0){
		c6=strdup("^1");
	}

}
//printf("done\n");
//printf("The number of connections are %d\n",no_connections);
if(no_connections<1 && pkcheck==0){
	six_dcheck=1;
	c6=strdup("n");
}

//printf("acheck is %d\n",acheck);
if(no_connections ==1){
	if(acheck==0){
	for(i=0;i<c6size;i++){
		if(strncmp(c6_connectatomnames[i],"O",1) == 0 && cycle_sorted[0].n == 6){
			hcheck=1;		
		}
	}
	}
}


if(no_connections >=2 && ncheck ==0){
	for(i=0;i<c6size;i++){
		if(strncmp(c6_connectatomnames[i],"C",1) == 0){
			ncheck=1;
		}
	}
	if(ncheck==0){
        //make sure to not count hydrogens
        	accheck=1;
	}
}


coord_3D **temp_c1_connectatoms;
temp_c1_connectatoms=(coord_3D**)calloc(1,sizeof(coord_3D*));
char **temp_c1_connectatomnames;
temp_c1_connectatomnames=(char**)calloc(1,sizeof(char**));
int temp_size=1;
if(c1size>1){
        for(i=0;i<c1size;i++){
                if(strncmp(c1_connectatomnames[i],"O",1) == 0){
                        temp_c1_connectatomnames[0]=strdup(c1_connectatomnames[i]);
                        temp_c1_connectatoms[0]=c1_connectatoms[i];
                }
                else{
                        temp_size++;
                        temp_c1_connectatomnames=(char**)realloc(temp_c1_connectatomnames,(temp_size*sizeof(char*)));
                        temp_c1_connectatomnames[temp_size-1]=strdup(c1_connectatomnames[i]);
                        temp_c1_connectatoms=(coord_3D**)realloc(temp_c1_connectatoms,(temp_size*sizeof(coord_3D*)));
                        temp_c1_connectatoms[temp_size-1]=c1_connectatoms[i];
                }

        }

for(i=0;i<c1size;i++){
        c1_connectatoms[i]=temp_c1_connectatoms[i];
        c1_connectatomnames[i]=strdup(temp_c1_connectatomnames[i]);
}

}






char *temp_c1="n";
vec_planes.i=planes[0].A;
vec_planes.j=planes[0].B;
vec_planes.k=planes[0].C;
//printf("c1size is %d\n",c1size);
vectormag_3D *vec_c1_connectatoms;
vec_c1_connectatoms=(vectormag_3D*)calloc(c1size,sizeof(vectormag_3D));
for(i=0;i<c1size;i++){
        vec_c1_connectatoms[i]=coord_to_vec(subtract_coord(ring_atoms[0][0],c1_connectatoms[i][0]));
        //dprint_coord_3D(&ring_atoms[0][0]);
        //dprint_coord_3D(&c1_connect_atoms[i][0]);
        //dprint_vectormag_3D(&vec_c1_connectatoms[i]);
}
int temp_check=0;
int fpcheck=0;
//printf("pkcheck is %d and ncheck is %d\n",pkcheck,ncheck);
//printf("cycle_sorted[0].n is %d\n",cycle_sorted[0].n);
if(c1size>1){
        for(i=0;i<c1size;i++){
                temp_check=0;
                d=get_dotprod(vec_planes,vec_c1_connectatoms[i]);
                //printf("%s\n",c1_connect_atomnames[i]);
                //printf("%lf\n",d);
		if(cycle_sorted[0].n == 5){
			if(strncmp(c1_connectatomnames[i],"O",1) == 0 && d<0.0){
                                strcpy(c1,"_a");
				fpcheck=1;
                                //printf("%s\n",temp_c1);
                        }
                        if(strncmp(c1_connectatomnames[i],"O",1) == 0 && d>0.0){
                                strcpy(c1,"^a");
				fpcheck=1;
                        }
		}


		if(pkcheck==1 || cycle_sorted[0].n == 6){
			//printf("inside if\n");
                	if(strncmp(c1_connectatomnames[i],"C",1) == 0 && d<0.0){
                        	temp_c1=strdup("_1");
                        	temp_check=1;
                	}
                	if(strncmp(c1_connectatomnames[i],"C",1) == 0 && d>0.0){
                        	temp_c1=strdup("^1");
				//printf("%s\n",temp_c1);
                        	temp_check=1;
                	}
                	if(strncmp(c1_connectatomnames[i],"O",1) == 0 && d<0.0){
                        	temp_c1=strdup("_a");
				//printf("%s\n",temp_c1);
                        	temp_check=1;
                	}
                	if(strncmp(c1_connectatomnames[i],"O",1) == 0 && d>0.0){
                        	temp_c1=strdup("^a");
                        	temp_check=1;
                	}
                	if(i==0 && temp_check==1){
                		strcpy(c1,temp_c1);
                	}
                	else{
                		if(temp_check==1){
                			strcat(c1,temp_c1);
                		}
                	}
        	}
		if(ncheck==1){
			if(strncmp(c1_connectatomnames[i],"C",1) == 0 && d<0.0){
				strcpy(c1,"_a");
			}
			if(strncmp(c1_connectatomnames[i],"C",1) == 0 && d>0.0){
                                strcpy(c1,"^a");
                        }
		}
		if(pkcheck==0 && ncheck==0 && cycle_sorted[0].n != 5){
			if(strncmp(c1_connectatomnames[i],"O",1) == 0 && d<0.0){
                                strcpy(c1,"_a");
                        }
			if(strncmp(c1_connectatomnames[i],"O",1) == 0 && d>0.0){
                                strcpy(c1,"^a");
                        }
		}

	}
//printf("%s\n",c1);

}
else{
	if(c1size==1){
		if(strcmp(c1_connectatomnames[0],"XX") == 0){
			strcpy(c1,"n");
		}
		
		else{
		d=get_dotprod(vec_planes,vec_c1_connectatoms[0]);
		//printf("The dot product of atom %s with plane 0 is %lf\n",connect_atomnames[0],d);
		if(d<0){
        		strcpy(c1,"_a");
        		//c1=strdup("_a");
		}
		if(d>0){
        		strcpy(c1,"^a");
        		//c1=strdup("^a");
		}
		}
	}
}

if(c1size==0){
	strcpy(c1,"n");
}

//printf("c1 is %s\n",c1);



if(cycle_sorted[0].n==6){
	//printf("the orienatations are %s%s%s%s%s\n",c1,c2,c3,c4,c6);
	//printf("the orientations are %s%s%sP%s%s\n",c2,c3,c4,c1,c6);
	if(c1size>1 && pkcheck ==1){
	strcpy((*sname).sugar_code,c2);
	strcat((*sname).sugar_code,c3);
	strcat((*sname).sugar_code,c4);
	strcat((*sname).sugar_code,"P");
	strcat((*sname).sugar_code,c1);
	}
	else{
	strcpy((*sname).sugar_code,c2);
        strcat((*sname).sugar_code,c3);
        strcat((*sname).sugar_code,c4);
        strcat((*sname).sugar_code,"P");
        strcat((*sname).sugar_code,c1);
	strcat((*sname).sugar_code,c6);
	}	
}

if(cycle_sorted[0].n==5){
        strcpy((*sname).sugar_code,c2);
        strcat((*sname).sugar_code,c3);
        strcat((*sname).sugar_code,"F");
        strcat((*sname).sugar_code,c1);
        strcat((*sname).sugar_code,c6);
	//printf("the orientations are %s%s%s%s\n",c1,c2,c3,c6);
	//printf("the orientations are %s%sF%s%s\n",c2,c3,c1,c6);
}
//printf("<<<sugar_code is %s>>>>\n",(*sname).sugar_code);

//printf("ncheck is %d\n",ncheck);

if(ncheck==0 && acheck==0 && accheck==0 && two_dcheck==0 && three_dcheck==0 && six_dcheck==0 && four_dcheck==0 && pkcheck==0){
	//printf("its a hexose\n");
	//printf("hcheck is %d\n",hcheck);
	if(cycle_sorted[0].n==6){
	hcheck=1;
	(*sname).sugar_type=strdup("HEXOSES");
	}
	if(cycle_sorted[0].n==5){
	hcheck=1;
	if(fpcheck==1){
	(*sname).sugar_type=strdup("FURANOSE_KETOSES");
	}
	else{
		(*sname).sugar_type=strdup("FURANOSE_PENTOSES");
	}
	}
	
}

if(ncheck==0 && acheck==0 && accheck==0 && pkcheck==0 &&hcheck==0){
	//printf("this is a deoxy sugar\n");
	if(two_dcheck ==1){
		//printf("this is a 2-deoxy sugar\n");
	}
	if(three_dcheck==1){
		//printf("this is a 3-deoxy sugar\n");
	}
	if(six_dcheck==1){
		//printf("this is a 6-deoxy sugar\n");
	}
	(*sname).deoxy=strdup("yes");
	(*sname).sugar_type=strdup("DEOXY");
}


if(pkcheck==1 && accheck==0 && ncheck==0 && hcheck==0 && two_dcheck==0 && three_dcheck==0 && four_dcheck==0 && six_dcheck==0){
	//printf("this is a pentose or ketose\n");
	//printf("pkcheck is %d\n",pkcheck);
	(*sname).sugar_type=strdup("PENTOSES_KETOSES");
}

if(pkcheck==0 && acheck==0 && ncheck==0 && hcheck==0 && two_dcheck==0 && three_dcheck==0 && four_dcheck==0 && six_dcheck==0){
	//printf("this is an acid\n");
	//printf("accheck is %d\n",accheck);
	(*sname).sugar_type=strdup("ACIDS");
}

//if(pkcheck==0 && acheck==0 && accheck==0 && hcheck==0 && three_dcheck==0 && six_dcheck==0){
	if(ncheck==1){
	//printf("this is a neuraminic acid\n");
	//printf("ncheck is %d and two_dcheck is %d\n",ncheck,two_dcheck);
	(*sname).sugar_type=strdup("NEURAMINICACID");
}

if(pkcheck==0 && ncheck==0 && accheck==0 && two_dcheck==0 && three_dcheck==0 && six_dcheck==0 && four_dcheck==0 && acheck==1){
	//printf("this is an amino derivative\n");
	//printf("acheck is %d and hcheck is %d\n",acheck,hcheck);
	(*sname).sugar_type=strdup("AMINO DERIVATIVES");
}

//printf("sugar_type is %s\n",(*sname).sugar_type);
//printf("deoxy is %s\n",(*sname).deoxy);

//printf("%d%d%d%d%d%d%d%d%d\n",accheck,acheck,ncheck,pkcheck,two_dcheck,three_dcheck,four_dcheck,six_dcheck,hcheck);

return sname;
}
